## Mapping

Mapping is one of the most awesome features of Rack applications.
It allows you to put together a bunch of seperate applications into a single one,
thus allowing you to create service architectures.

Let's see how it works:

```ruby
  require "pretzel/core"

  class Application < Pretzel::Core
  end

  class SubApplication < Pretzel::Core
  end

  SubApplication.get "/test" do
    "Hello, SubApplication"
  end

  Application.get "/" do
    "Hello, MainApplication"
  end

  Application.map "/sub" do
    run SubApplication.new
  end
```

Now in this setup whenever you access a route that's on the `/sub` route, you will
get forwarded to the routes of the `SupApplication`. 

Thus when you access `/sub/test` you will get the response `Hello, SubApplication`
If you use this efficiently you can build an application on the so-called service
architecture, which is pretty neat!
