## Convenience methods

The Pretzel suite comes with a set of three convenience methods. These are not part of
the Core framework, but are still included with every Pretzel project via the ways
of Pretzel::Core.

The convenience methods are defined in `Pretzel::Extension::Convenience` and the following
are available:

* redirect
* session
* status

**NOTE:** All convenience functions are only available in the *route blocks.*

### redirect(url)

The `redirect` function allows you to easily execute a HTTP redirect to another URL
of your application. It only takes a single argument and is called like this:

```ruby
	redirect "/redirect-page"
```

### session

The `session` method is probably the most useful of the convenience functions. It
does what it says on the tin: Handle a session. It's already all setup with signed
cookies by the Pretzel::Core, so you can use it right away. It can be interacted
with as a regular Hash. It's just a thin wrapper around `request.session`.

```ruby
	session[:my_var] = "Hello, World" # Set a session variable
	session[:my_var] 									# => "Hello, World"
```

### status(status)

`status` is a simple wrapper around response.status that allows you to set the HTTP
status of your response. This is usually done with APIs to indicate various success
and error states. `status` takes a single argument

```ruby
	status 201 # Set the status to "Resource created"
```