## JSON

The Pretzel suite comes with a predelivered JSON extension (`Pretzel::Extension::JSON`)
that helps you easily send JSON responses for an API or something similar. It is a non-core
extension and you have to manually add it to your application.

You can include it like this:

```ruby
	require "pretzel/core"
	require "pretzel/ext/json"

	class Application < Pretzel::Core
		extends Pretzel::Extension::JSON
	end
```

And you're ready to go! The JSON module only provides a single method: `json`.
You can call this method with two parameters: A Hash and a `status`.

Only the hash is required. If you do not set a status, the response will just return
the status `200 OK`.

Calling it looks like this:

```ruby
	Application.get "/json" do
		json({
			:hello => "world"
		}, 201)
	end
```

This sets the response status to 201, the content type to "application/json" and
converts the Hash to JSON according to the specification.