require_relative "setup_environment"

class ConvenienceApplication < Pretzel::Core; end

# Testing convenience methods
ConvenienceApplication.get "/status" do
  status 201
end

ConvenienceApplication.get "/redirect" do
  redirect "/redirected"
end

ConvenienceApplication.get "/redirected" do
  "Redirected to here"
end

ConvenienceApplication.get "/stop" do
  halt 500, "Woops"
  "Not seen"
end

ConvenienceApplication.get "/session/set" do
  session[:test] = "Test variable"
  "Session variable set"
end

ConvenienceApplication.get "/session/get" do
  session[:test] = "Test variable"
  session[:test]
end

class TestConvenience < Minitest::Test
  include Rack::Test::Methods

  def app
    ConvenienceApplication.new
  end

  def test_status
    get "/status"
    assert_equal 201, last_response.status
  end

  def test_halt
    get "/stop"
    assert_equal 500, last_response.status
    assert_equal "Woops", last_response.body
  end

  def test_redirect
    get "/redirect"
    follow_redirect!
    assert last_response.body.include? "Redirected"
  end

  def test_session_setter
    get "/session/set"
    assert_equal "Session variable set", last_response.body
  end

  def test_session_getter
    get "/session/get"
    assert_equal "Test variable", last_response.body
  end
end