require_relative "setup_environment"

module Pretzel
  module Extension
    class Test
      module Instance

      end

      module App
        def class_method
          "Class method"
        end
      end

      module Route
        def instance_method
          "Instance method"
        end        

        def self.included(app)
          app.get "/ext/index" do
            render :index
          end

          app.get "/ext/instance" do
            instance_method
          end
        end
      end

    end
  end
end

class ExtensionApplication < Pretzel::Core
  extends Pretzel::Extension::Templating
  extends Pretzel::Extension::Test
end

class TestExtension < Minitest::Test
  include Rack::Test::Methods

  def app
    ExtensionApplication.new
  end

  def test_extension_route
    get "/ext/index"
    assert last_response.body.include? "Hello, World!"
  end

  def test_extension_classmethod  
    assert_equal ExtensionApplication.class_method, "Class method"
  end

  def test_extension_instancemethod  
    get "/ext/instance"
    assert_equal last_response.body, "Instance method"
  end  
end