require_relative "setup_environment"

class FilterApplication < Pretzel::Core; end

FilterApplication.before do
  if request.path_info.eql? "/before"
    response.write "BEFORE::"
  end
end

FilterApplication.after do
  if request.path_info.eql? "/after"
    response.write "::AFTER"
  end
end

FilterApplication.get "/before" do
  "TEST"
end

FilterApplication.get "/after" do
  "TEST"
end

class TestFilters < Minitest::Test
  include Rack::Test::Methods

  def app
    FilterApplication.new
  end

  def test_before
    get "/before"
    assert_equal "BEFORE::TEST", last_response.body
  end

  def test_after
    get "/after"
    assert_equal "TEST::AFTER", last_response.body
  end
end