require_relative "setup_environment"
require "rack"

class JSONApplication < Pretzel::Core 
  extends Pretzel::Extension::JSON
end

JSONApplication.get "/" do
  json({ :hello => "world"})
end

JSONApplication.get "/with-status" do
  json({ :hello => "status"}, 400)
end

class TestJSON < Minitest::Test
  include Rack::Test::Methods

  def app
    JSONApplication.new
  end

  def test_content_type
    get "/"
    assert_equal last_response["Content-Type"], "application/json"
  end

  def test_status
    get "/"
    assert_equal last_response.status, 200
  end

  def test_serialization
    get "/"
    assert last_response.body.eql? %({"hello":"world"})
  end

  def test_custom_status
    get "/with-status"
    assert_equal last_response.status, 400
  end
end