require_relative "setup_environment"

class MapApplication < Pretzel::Core; end
class SubApplication < Pretzel::Core; end

MapApplication.get "/" do
  "MapApplication main"
end

MapApplication.get "/test" do
  "MapApplication test"
end

SubApplication.get "/" do
  "SubApplication main"
end

SubApplication.get "/test" do
  "SubApplication test"
end

MapApplication.map "/sub" do
  run SubApplication.new
end

class TestMapping < Minitest::Test
  include Rack::Test::Methods
  def app
    MapApplication.new
  end

  def test_map_main
    get "/"
    assert_equal "MapApplication main", last_response.body
  end

  def test_map_route
    get "/test"
    assert_equal "MapApplication test", last_response.body
  end

  def test_sub_main
    get "/sub"
    assert_equal "SubApplication main", last_response.body
  end

  def test_sub_route
    get "/sub/test"
    assert_equal "SubApplication test", last_response.body
  end
end