require_relative "setup_environment"

class Middleware
  def initialize(app)
    @app = app
  end

  def call(env)
    status, headers, res = @app.call(env)
    [status, headers, [res.body.first.capitalize]]
  end
end

class MiddlewareApplication < Pretzel::Core
  use Middleware
end

MiddlewareApplication.get "/" do
  "hello"
end

class TestMiddleware < Minitest::Test
  include Rack::Test::Methods

  def app
    MiddlewareApplication.new
  end

  def test_middleware
    get "/"
    assert_equal "Hello", last_response.body
  end
end