require_relative "setup_environment"

class RoutingApplication < Pretzel::Core; end

# Intense case of DRY below here.
# Setting up HTTP methods.
%w(GET POST DELETE PUT OPTIONS HEAD).each do |verb|
  method = RoutingApplication.method(verb.downcase)
  method.call("/") do
    "Hello, #{verb}"
  end
end

# GET and POST parameters.
%w(GET POST).each do |verb|
  method = RoutingApplication.method(verb.downcase)
  method.call("/parameter/:param") do 
    %(Hello, #{parameters["param"]})
  end
end

class TestRouting < Minitest::Test
  %w(GET POST DELETE PUT OPTIONS HEAD).each do |verb|
    define_method("test_#{verb.downcase}") do
      req = Rack::MockRequest.new(RoutingApplication.new)
      req_method = req.method(verb.downcase)
      res = req_method.call("/")

      assert_equal "Hello, #{verb}", res.body
    end
  end
end